Bugzilla will be upgraded to version 5.0 on a still to be determined date in the near future. The original upgrade date has been delayed.
Bug 613407 - assertion failure at namet.adb:616 (causes broken dependencies)
assertion failure at namet.adb:616 (causes broken dependencies)
Status: ASSIGNED
Product: Fedora
Classification: Fedora
Component: gcc (Show other bugs)
28
All Linux
low Severity medium
: ---
: ---
Assigned To: Jakub Jelinek
Fedora Extras Quality Assurance
: Reopened
: 690610 709436 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-07-11 07:33 EDT by Björn Persson
Modified: 2018-02-20 10:22 EST (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-12-27 23:58:54 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
patch to look for libgnat.so if libgnat.a is missing (1.15 KB, patch)
2010-08-01 20:18 EDT, Björn Persson
no flags Details | Diff


External Trackers
Tracker ID Priority Status Summary Last Updated
GNU Compiler Collection 49337 None None None Never

  None (edit)
Description Björn Persson 2010-07-11 07:33:44 EDT
Description of problem:
With GCC 4.5 came a libgnat-4.5.0-1 package, which broke dependencies of Ada programs and binaries linked to libgnat-4.4.so. When I tried to rebuild PragmARC I hit an internal error in Gnatmake. PragmARC is a dependency of mine_detector. Thus I have two broken packages that I can't fix.

Version-Release number of selected component (if applicable):
4.5.0-1.fc14

How reproducible:
Every time, in Koji, Mock under x86-64 F13, and a real i686 Rawhide system.

Steps to Reproduce:
1. Try to rebuild PragmARC in Rawhide.
  
Actual results:
After Gnatmake has executed Gnatbind it prints these messages:
Exception name: SYSTEM.ASSERTIONS.ASSERT_FAILURE
Message: namet.adb:616
gnatmake: INTERNAL ERROR. Please report.

Expected results:
a rebuilt package

Additional info:
Comment 1 Bug Zapper 2010-07-30 08:30:11 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 14 development cycle.
Changing version to '14'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 2 Björn Persson 2010-08-01 08:27:38 EDT
This is where it fails:

Breakpoint 1, system.assertions.raise_assert_failure (msg=...) at s-assert.adb:43
43	   procedure Raise_Assert_Failure (Msg : String) is
(gdb) bt
#0  system.assertions.raise_assert_failure (msg=...) at s-assert.adb:43
#1  0x080c3366 in namet.get_name_string (id=300000000) at /usr/src/debug/gcc-4.5.0-20100716/gcc/ada/namet.adb:616
#2  0x080c0b03 in mlib.utl.lib_directory () at /usr/src/debug/gcc-4.5.0-20100716/gcc/ada/mlib-utl.adb:613
#3  0x080b89cc in mlib.prj.build_library (in_tree=0x85150a0, gnatbind=..., gnatbind_path=..., gcc=..., gcc_path=..., link=true) at /usr/src/debug/gcc-4.5.0-20100716/gcc/ada/mlib-prj.adb:1548
#4  0x080abdcd in make.gnatmake () at /usr/src/debug/gcc-4.5.0-20100716/gcc/ada/make.adb:5744
#5  0x0804a275 in main (argc=17, argv=0xbffff544, envp=0xbffff58c) at b_gnatm.c:476
#6  0x005f6cf6 in __libc_start_main (main=0x804a230 <main>, argc=17, ubp_av=0xbffff544, init=0x8166d70 <__libc_csu_init>, fini=0x8166dd0 <__libc_csu_fini>, rtld_fini=0x5cbc50 <_dl_fini>, stack_end=0xbffff53c)
    at libc-start.c:226
#7  0x08049b41 in _start ()
(gdb) frame 2
#2  0x080c0b03 in mlib.utl.lib_directory () at /usr/src/debug/gcc-4.5.0-20100716/gcc/ada/mlib-utl.adb:613
613	      Get_Name_String (Osint.Find_File (Name_Enter, Osint.Library));
(gdb) p Name_Buffer(1 .. Name_Len)
$1 = "libgnat.a"
(gdb) p Integer(Osint.Library)
$2 = 1
(gdb) p Osint.Find_File(Name_Enter, 1)
$3 = 300000000
(gdb) p Namet.No_File
$4 = 300000000

Lib_Directory tries to find the directory that contains libgnat by looking for libgnat.a, but Find_File returns No_File because libgnat.a is missing. Installing libgnat-static works around the problem when building locally.
Comment 3 Peter Lemenkov 2010-08-01 10:43:27 EDT
It looks like a packaging bug for me (not an issue in GCC itself). I hope it's true.
Comment 4 Björn Persson 2010-08-01 20:18:58 EDT
Created attachment 435931 [details]
patch to look for libgnat.so if libgnat.a is missing

If Gnat is meant to work with only shared libraries installed, then i guess it's a GCC issue. Otherwise it's a packaging bug.

I think this patch will make Gnatmake find the directory even when only the shared libraries are present, but I haven't been able to test it because my attempts to rebuild the GCC packages keep failing in various other places.
Comment 5 Björn Persson 2010-08-08 20:15:05 EDT
I have now confirmed that the patch works on my Rawhide system.
Comment 6 Björn Persson 2010-08-22 20:22:08 EDT
If my patch is unacceptable for some reason, can we please let libgnat-devel require libgnat-static until Gnat learns to function without the static libraries?
Comment 7 Björn Persson 2011-06-08 18:49:14 EDT
*** Bug 709436 has been marked as a duplicate of this bug. ***
Comment 8 Björn Persson 2011-06-08 18:50:38 EDT
*** Bug 690610 has been marked as a duplicate of this bug. ***
Comment 9 Aravind vijayan 2011-12-27 23:58:54 EST
    Thank you for your bug report. 

    We are sorry, but the Fedora Project is no longer releasing bug fixes or any other updates for this version of Fedora. This bug will be set to CLOSED:WONTFIX to reflect this, but please reopen it if the problem persists after upgrading to the latest version of Fedora, which is available from: 

    http://fedoraproject.org/get-fedora 



-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers
Comment 10 Björn Persson 2011-12-29 02:46:33 EST
still present in 4.6.2-1.fc17.1
Comment 11 Björn Persson 2012-01-10 17:38:57 EST
(In reply to comment #10)
> still present in 4.6.2-1.fc17.1

And, for the record, in 4.7.0-0.5.fc17.
Comment 12 Fedora End Of Life 2013-04-03 16:05:00 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 13 Fedora End Of Life 2015-01-09 16:44:42 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 14 Björn Persson 2015-01-10 16:20:43 EST
Gnatmake still doesn't work without libgnat-static installed, and there is still no RPM dependency reflecting this.
Comment 15 Jan Kurik 2015-07-15 11:19:12 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 23 development cycle.
Changing version to '23'.

(As we did not run this process for some time, it could affect also pre-Fedora 23 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 23 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora23
Comment 16 Fedora End Of Life 2016-11-24 05:27:50 EST
This message is a reminder that Fedora 23 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 23. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '23'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 23 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 17 Fedora End Of Life 2017-11-16 13:31:43 EST
This message is a reminder that Fedora 25 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 25. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '25'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 25 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.
Comment 18 Fedora End Of Life 2018-02-20 10:22:32 EST
This bug appears to have been reported against 'rawhide' during the Fedora 28 development cycle.
Changing version to '28'.

Note You need to log in before you can comment on or make changes to this bug.